#!/usr/bin/env -S deno run --allow-read --allow-write

import { config_json_schema } from "./lib/conf.ts"
import { dirname, join } from "https://deno.land/std@0.224.0/path/mod.ts"

await main()
async function main() {
	await generate_schema()
}

async function generate_schema() {
	const schema = config_json_schema()
	const text = JSON.stringify(schema, null, 4)
	const path = join(await project_root(), "asset", "config_schema.json")
	await Deno.writeTextFile(path, text)
	console.log("[gen.ts] generate_schema to", path)
}

async function project_root() {
	const path = new URL(import.meta.url).pathname
	const this_file = await Deno.realPath(path)
	return dirname(dirname(this_file))
}
