import { Task, Todo, todo_completed } from "./task.ts"

import { crayon } from "https://deno.land/x/crayon@3.3.3/mod.ts"

export function print_todo(todo: Todo) {
	console.log()
	console.log(" ".repeat(4) + crayon.white.bold("TODO"))
	console.log("─".repeat(40))
	console.log()
	const done = todo.tasks.filter((t) => todo_completed(t))
	const not_done = todo.tasks.filter((t) => !todo_completed(t))

	for (const task of done) {
		print_task(task, 1)
		console.log()
	}

	for (const task of not_done) {
		print_task(task, 1)
		console.log()
	}
}

function print_task(task: Task, depth = 0) {
	const indent = "  ".repeat(depth)
	const line = indent + (task.done ? crayon.bold.blue("×") : crayon.bold.yellow("•")) + " " +
		crayon.white(task.title)
	console.log(line)
	for (const descr of task.descriptions) console.log(indent + " ", descr)
	for (const sub of task.subtasks.filter((s) => s.done)) print_task(sub, depth + 1)
	for (const sub of task.subtasks.filter((s) => !s.done)) print_task(sub, depth + 1)
}
