#!/usr/bin/env -S deno run --allow-all

import { read_conf } from "./lib/conf.ts"
import { print_todo } from "./lib/display.ts"
import { fetch_repo, link_todo } from "./lib/repo.ts"
import { read_todo } from "./lib/task.ts"

await main()
async function main() {
	const config = await read_conf()
	await fetch_repo(config.repo_path, config.remote_url)
	await link_todo(config.repo_path, config.file_path)
	const todo = await read_todo(config.file_path)
	print_todo(todo)
}
